﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Bingo
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		// @Load
		private void Form1_Load(object sender, EventArgs e)
		{
			// ImageListを一応作成
			listView1.SmallImageList = new ImageList();
			// 幅を1/5に合わせる
			listView1.Columns[0].Width = listView1.Width / 5 - 1;
			listView1.Columns[1].Width = listView1.Width / 5 - 1;
			listView1.Columns[2].Width = listView1.Width / 5 - 1;
			listView1.Columns[3].Width = listView1.Width / 5 - 1;
			listView1.Columns[4].Width = listView1.Width / 5 - 1;
			listView1.SmallImageList.ImageSize = new Size(1, listView1.Height / 5 - 1);
			// 予め選択
			comboBox1.SelectedIndex = 0;
			comboBox2.SelectedIndex = 0;
			comboBox3.SelectedIndex = 24;

		}

		// MIN Level Changed
		private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
		{
			// もし最低指定レベルより最高指定レベルの方が低ければ同じにする
			if(comboBox3.SelectedIndex < comboBox2.SelectedIndex){
				comboBox3.SelectedIndex = comboBox2.SelectedIndex;
			}
		}

		// MAX Level Changed
		private void comboBox3_SelectedIndexChanged(object sender, EventArgs e)
		{
			// もし最高指定レベルより最低指定レベルの方が高ければ同じにする
			if(comboBox2.SelectedIndex > comboBox3.SelectedIndex){
				comboBox2.SelectedIndex = comboBox3.SelectedIndex;
			}
		}

		// SizeChanged
		private void listView1_SizeChanged(object sender, EventArgs e)
		{
			// 幅を1/5に合わせる
			listView1.Columns[0].Width = listView1.Width / 5 - 1;
			listView1.Columns[1].Width = listView1.Width / 5 - 1;
			listView1.Columns[2].Width = listView1.Width / 5 - 1;
			listView1.Columns[3].Width = listView1.Width / 5 - 1;
			listView1.Columns[4].Width = listView1.Width / 5 - 1;
			listView1.SmallImageList.ImageSize = new Size(1, listView1.Height / 5 - 1);
		}

		// Auto UnSelected
		private void listView1_SelectedIndexChanged(object sender, EventArgs e)
		{
			if(listView1.SelectedItems.Count > 0){
				listView1.SelectedItems[0].Selected = false;
			}
		}

		// Genelate
		private void button1_Click(object sender, EventArgs e)
		{
			// もし必要な項目が入力されていないならば
			if(comboBox1.SelectedIndex == -1
			|| comboBox2.SelectedIndex == -1
			|| comboBox3.SelectedIndex == -1){
				// 警告
				MessageBox.Show("必要な項目が指定されてないっぽい");
				return;
			}
			// DataBaseから条件に一致する曲を引っ張りだす
			var Songs = SongsDataBase.AllSongDatas.FindAll(
				delegate(SongData Dt){
					var SgLv = Dt.GetThisSongClearLevel(comboBox1.SelectedIndex == 1);
					var MinLv = comboBox2.SelectedIndex + 1;
					var MaxLv = comboBox3.SelectedIndex + 1;
					return ( SgLv >= MinLv && SgLv <= MaxLv );
				}
			);
			// シャッフルする
			var ShuffleSongs = Songs.OrderBy(i => Guid.NewGuid()).ToArray();
			// 曲データを順番に適用する
			for(int Main = 0; Main <= 4; Main++){
				for(int Sub = 0; Sub <= 4; Sub++){
					// 一応初期化
					listView1.Items[Main].SubItems[Sub].Text = "";
					// SubItemに独自Styleを適用させる
					listView1.Items[Main].UseItemStyleForSubItems = false;
					// FREEが有効なら
					if(Main == 2 && Sub == 2 && checkBox1.Checked){
						// FREEに指定する
						listView1.Items[2].SubItems[2].Text = "FREE";
						listView1.Items[2].SubItems[2].ForeColor = Color.Purple;
						// 続行
						continue;
					}
					// 有効な領域か確認してダメそうなら終わり
					if(ShuffleSongs.Length <= Main*5+Sub){
						continue;
					}
					// 登録する
					listView1.Items[Main].SubItems[Sub].Text
						= ShuffleSongs[Main*5+Sub].Name;
					listView1.Items[Main].SubItems[Sub].ForeColor
						= ShuffleSongs[Main*5+Sub].GetDifficultlyColor();
				}
			}
			// 画像作成を有効に
			button2.Enabled = true;
		}

		// 画像作成
		private void button2_Click(object sender, EventArgs e)
		{
			// Bitmapの作成
			Bitmap Bmp = new Bitmap(listView1.Width, listView1.Height);
			// キャプチャ
			listView1.DrawToBitmap(Bmp, new Rectangle(0, 0, listView1.Width, listView1.Height));
			// Save Path
			String SavePath = "Card/" + DateTime.Now.ToShortDateString().Replace("/", "")
				+ " " + DateTime.Now.ToLongTimeString().Replace(":", "_") + ".png";
			// 保存
			Bmp.Save(SavePath);
			// 表示
			MessageBox.Show("ビンゴカード画像を" + SavePath + "に保存しました．");
		}
	}
}
